#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include "sstr.h"

void oom();

/*TODO: use a hash or maybe sorted array of elements for faster access */
/*TODO: not string but buffer: accept length */

struct sstr {
  unsigned used;
  struct sstr *next;
  char str[1];
};

static struct sstr *sl, *last;
void sstrstat() {}

char *sstrdup(const char *str) {
  struct sstr *s;
  if (last && strcmp(last->str, str) == 0) {
    ++last->used;
    return last->str;
  }
  for(s = sl; s; s = s->next)
    if (strcmp(str, s->str) == 0) {
      last = s;
      ++s->used;
      return s->str;
    }
  s = (struct sstr*)malloc(sizeof(*s) + strlen(str));
  if (!s) {
    oom();
    return NULL;
  }
  strcpy(s->str, str);
  s->used = 1;
  s->next = sl;
  sl = last = s;
  return s->str;
}

void sstrfree(char *str) {
  struct sstr *s = (struct sstr *)(str - offsetof(struct sstr, str));
  if (!str) return;
  if (--s->used != 0) return;
  if (s == sl)
    sl = s->next;
  else {
    struct sstr *p = sl;
    while(p->next != s)
      if (!p->next) abort();
      else p = p->next;
    p->next = s->next;
  }
  free(s);
  if (last == s) last = NULL;
}

char *sstrref(char *str) {
  if (str)
    ((struct sstr *)(str - offsetof(struct sstr, str)))->used++;
  return str;
}
